# -*- coding: utf-8 -*-

"""
    greenbyteapi

    This file was automatically generated by APIMATIC v2.0 ( https://apimatic.io ).
"""

import dateutil.parser

class PersonnelSiteInduction(object):

    """Implementation of the 'PersonnelSiteInduction' model.

    A site induction.

    Attributes:
        site_induction_id (int): The id of a personnel site induction.
        site_id (int): The id of a site.
        date_expires (date): When the site induction expires.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "site_induction_id":'siteInductionId',
        "site_id":'siteId',
        "date_expires":'dateExpires'
    }

    def __init__(self,
                 site_induction_id=None,
                 site_id=None,
                 date_expires=None):
        """Constructor for the PersonnelSiteInduction class"""

        # Initialize members of the class
        self.site_induction_id = site_induction_id
        self.site_id = site_id
        self.date_expires = date_expires


    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object as
            obtained from the deserialization of the server's response. The keys
            MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """
        if dictionary is None:
            return None

        # Extract variables from the dictionary
        site_induction_id = dictionary.get('siteInductionId')
        site_id = dictionary.get('siteId')
        date_expires = dateutil.parser.parse(dictionary.get('dateExpires')).date() if dictionary.get('dateExpires') else None

        # Return an object of this model
        return cls(site_induction_id,
                   site_id,
                   date_expires)


